/*
 * $Id: 49fc4403845d8e872dd45f90f5a428af4abc5918 $
 *
 * This file is part of nsmtp.
 *
 * Copyright (c) 2007, 2008 Niklas Olmes <niklas@noxa.de>
 *                          http://www.nevm.de/nsmtp/
 *                          NEVM-RIPE
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2
 * as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 *
 */

#ifndef HAD_LIBNSMTP_CONFIG_H
#define HAD_LIBNSMTP_CONFIG_H

#include "ntlc.h"

#define NSMTP_DEFAULT_CONFIG	"/var/nsmtp/nsmtp.cfg"

extern char *nsmc_name;
extern char *nsmc_alias;
extern char *nsmc_domain;
extern char *nsmc_ip;

extern char **nsmc_ports;
extern char **nsmc_ports_ssl;

extern char *nsmc_mail_root;
extern char *nsmc_nologin;
extern char *nsmc_cleanpath;

extern char *nsmc_pidfile_dir;

extern unsigned int nsmc_smtpd_uid;
extern unsigned int nsmc_smtpd_gid;
extern char *nsmc_smtpd_chroot;
extern int nsmc_smtpd_maxchilds;
extern int nsmc_smtpd_error_threshold_soft;
extern int nsmc_smtpd_error_threshold_hard;
extern int nsmc_smtpd_noop_threshold;

extern unsigned int nsmc_smtpr_uid;
extern unsigned int nsmc_smtpr_gid;
extern char *nsmc_smtpr_chroot;

extern unsigned int nsmc_smtps_uid;
extern unsigned int nsmc_smtps_gid;

extern char *nsmc_ssl_server_pem;

extern char *nsmc_ldap_cfg_file;

extern char *nsmc_legacyauth_file;

extern unsigned int nsmc_smtp_timeout;

extern unsigned int nsmc_default_maildir_uid;
extern unsigned int nsmc_default_maildir_gid;
extern unsigned int nsmc_maildir_uid_range_low;
extern unsigned int nsmc_maildir_uid_range_high;

extern char *nsmc_mail_basedn;
extern char *nsmc_mail_regex;

extern char *nsmc_spool_root;
extern char *nsmc_spool_lock;
extern char *nsmc_spool_defer;

extern int nsmc_relay_timeout;
extern char *nsmc_relay_root;
extern char *nsmc_relay_banned;
extern char *nsmc_relay_temporary;
extern char *nsmc_relay_permanent;

extern char *nsmc_greylist_rcpt_db;
extern int nsmc_greylist_rcpt_wait;
extern int nsmc_greylist_rcpt_autowhite_timeout;
extern int nsmc_greylist_rcpt_whitelist_timeout;

extern char *nsmc_greylist_spf_db;
extern int nsmc_greylist_spf_wait;
extern int nsmc_greylist_spf_autowhite_timeout;
extern int nsmc_greylist_spf_whitelist_timeout;

extern char *nsmc_whitelist_host_db;
extern int nsmc_whitelist_host_timeout;

extern char *nsmc_spam_mailbox;

extern int nsmc_spool_max_defers;
extern int nsmc_spool_max_age;

extern char **nsmc_virscan_hosts;
extern char **nsmc_spamscan_hosts;

extern NTL_CFG **nsmc_ldap_cfgs;

extern int nsm_config_error;
extern int nsm_config_error_line;
extern char *nsm_config_error_file;
extern const char *nsm_config_error_str;

int nsm_config_read(const char *);
int nsm_config_check(void);
void nsm_config_free(void);
void nsm_config_perror(const char *) __attribute__((noreturn));

#endif
